const MAX_HEARTS = 10;
const START_HEARTS = 5;
const PIGEON_START_X = 1280 / 2;
const PIGEON_START_Y = 0;
const PIGEON_VELOCITY = 200;
const HITBOXES = {
  'scarecrow': [100, 340, 20, 10],
  'haybale': [150, 150, 25, 20],
  'pumpkin': [70, 70, 5, 10],
  'pitchfork': [100, 3700, 0, 100],
  'balloon': [70, 70, 5, 5],
  'ground': [100000, 100000, 0, 650],
  'ground2': [100000, 100000, 0, 650],
  'bigCactus': [80, 340, 120, 10],
  'hotAirBalloon': [255, 300, 10, 0],
  'vw': [680, 350, 45, 5],
  'lantern': [50, 400, 0, 15],
  'desertCloud1': [150, 100, 15, 20],
  'desertCloud2': [50, 80, 10, 10],
  'hell2': [180, 460, 20, -200],
  'hell3': [100, 166, 40, 20],
  'hell5': [100, 1000, 70, 20],
  'hell6': [200, 350, 180, -200],
  'hell7': [90, 1000, 87, 10],
  'hell8': [20, 500, 60, -200],
  'hell10': [50, 680, 180, -200],
  'hell11': [180, 270, 15, 20],
  'gandalf': [249, 462, 20, 60],
  'bench': [400, 204, 20, 20],
  'letterbox': [0, 0, 0, 0],
}
const SCALING = {
  'pitchfork': 0.1,
}

function getNextLevel(level) {
  switch(level) {
    case 'level0': return 'level1';
    case 'level1': return 'level2';
    case 'level2': return 'level3';
    case 'level3': return 'level0';
              }
}


window.onload = function() {
  
  var bootState = {
    winner: false,
    panned: false,
    init: function(params) {
      this.winner = params.winner == true;
      this.panned = params.panned == true;
      
      this.initial = params.initial == true;
      this.nextLevel = params.nextLevel ? params.nextLevel : 'level0';
    },
    preload: function() {
      // enable loading assets from different domain
      game.load.crossOrigin = true
      // load assets
      game.load.spritesheet('pigeon', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fpigeon-small.png?1517059911387', 128, 120);    
      game.load.spritesheet('panny', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fpanny-animation.png?1517142792415', 219, 163);
      game.load.image('placeholder', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fplaceholder.png?1517044599391');
      game.load.image('pumpkin', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fdabaedac-783d-482a-b0f3-39f930b418bd_pumpkin.png?1517061264329');
      game.load.image('haybale', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fhaybalemedium.png?1517063404415');
      game.load.image('scarecrow', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fdabaedac-783d-482a-b0f3-39f930b418bd_scarecrow.png?1517062120929');
      game.load.image('balloon', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fobstacle-balloon.png?1517078374424');
      game.load.image('pitchfork', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fpitchfork.png?1517070838104');
      game.load.image('food-placeholder', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Ffood-placholder.png?1517047801271');
      game.load.image('background', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fpidgeon-bg2.png?1517057006211');
      game.load.image('ground', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fpidgeon-bg-ground.png?1517073518714');
      game.load.image('background1', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FDesertBG.png?1517062809757');
      game.load.image('background2', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fground%20city.png?1517132840772');
      game.load.image('background2a', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fcity-skyline.png?1517075154735');
      game.load.image('background2b', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fcity-houses.png?1517075154700');
      game.load.image('ground2', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fbg-city.png?1517074947298');
      game.load.image('background3', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FHellBG%20full.png?1517128083837');
      game.load.image('heart', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fpixel-heart.png?1517050760944");
      game.load.image('bread', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Food%20bun.png?1517072341282");
      game.load.image('seeds', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Food%20bird%20food.png?1517072341365");
      game.load.image('fruit', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Food%20raspberry.png?1517072341462");
      game.load.image('pizza', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Food%20pizza.png?1517072341472");
      game.load.image('worms', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Food%20worms.png?1517072341617");
      game.load.image('bigCactus', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Desert%20cactus%20big.png?1517063427249");
      game.load.image('littleCactus', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Desert%20cactus%20small.png?1517063430808");
      game.load.image('statue', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Desert%20Statue.png?1517063439412");
      game.load.image('pigeonStatue', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Desert%20Pigeon.png?1517063435555");
      game.load.image('rock', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Desert%20rock%20alone.png?1517063516067");
      game.load.image('rockCave', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Desert%20rock%20plant.png?1517063597296");
      game.load.image('desertCloud1', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Desert%20Cloud%201.png?1517133768927");
      game.load.image('desertCloud2', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Desert%20Cloud%202.png?1517133768761");
      game.load.image('lantern', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fobstacle-lantern.png?1517078847651");
      game.load.image('vw', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fobstacle-vw.png?1517081570839");
      game.load.image('hotAirBalloon', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fobstacle-hot%20air%20balloon.png?1517083469734");
      game.load.image('bench', "https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fobstacle-bench.png?1517085779496");
      game.load.image('title-screen', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fpidge-title2.png?1517137659713');
      game.load.image('panned-screen', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FPanned.png?1517132636897');
      game.load.image('pan', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fobstacle-panny.png?1517078142984');
      game.load.image('bigCactus-fix', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fdabaedac-783d-482a-b0f3-39f930b418bd_Asset%20Desert%20cactus%20big.png?1517086496609');
      
      game.load.image('hell1', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Rock%201.png?1517127842124');
      game.load.image('hell2', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Rock%202.png?1517127842434');
      game.load.image('hell3', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Rock%203.png?1517127842133');
      game.load.image('hell4', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Rock%204.png?1517127841872');
      game.load.image('hell5', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Rock%205.png?1517127842580');
      game.load.image('hell6', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Rock%206.png?1517127842500');
      game.load.image('hell7', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Rock%207.png?1517127843192');
      game.load.image('hell8', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Rock%208.png?1517127842142');
      game.load.image('hell9', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Rock%209.png?1517127842405');
      game.load.image('hell10', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Rock%2010.png?1517127843241');
      game.load.image('hell11', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Rock%2011.png?1517127842451');
      game.load.image('hell12', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Rock%2012.png?1517127842574');
      game.load.image('hellsign1', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Shield%201.png?1517127843180');
      game.load.image('hellsign2', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Shield%202.png?1517127843180');
      game.load.image('hellsign3', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2FAsset%20Hell%20Shield%203.png?1517127842476');
      game.load.image('gandalf', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fobstacle-gandalf.png?1517133566041');
      game.load.image('bat', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fderpy%20bat.png?1517128248433');
      game.load.image('letterbox-closed', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fmailbox%20closed.png?1517139272229');
      game.load.image('letterbox-open', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fmailbox%20open.png?1517139272229');
      game.load.image('win-screen', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fmessage%20delivered.png?1517146465095');
      game.load.image('gandalf-rock', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fgandalf-rock.png?1517147562735');
      // load music
      game.load.audio('music', 'https://cdn.glitch.com/dabaedac-783d-482a-b0f3-39f930b418bd%2Fpidgeon%20flight.mp3?1517092286916');
      // load levels
      game.load.json('level0', 'level0.json');
      game.load.json('level1', 'level1.json');
      game.load.json('level2', 'level2.json');
      game.load.json('level3', 'level3.json');
    },
    create: function() {
      if (this.initial) {
        var music = game.add.audio('music', 1, true);
        music.play();
      }
      if (this.winner) {
        game.add.image(0, 0, 'win-screen'); 
      } else if (this.panned) {
        game.add.image(0, 0, 'panned-screen');
        game.add.text(30, 660, "Press enter to try again", {font: '30px Arial', fill: '#fff'});
      } else {
        game.add.image(0, 0, 'title-screen'); 
        game.add.text(30, 660, "Press enter to take off", {font: '30px Arial', fill: '#fff'});
      }
      
      var startKey = game.input.keyboard.addKey(Phaser.Keyboard.ENTER);
      startKey.onDown.addOnce(this.startGame.bind(this));
    },
    startGame: function() {
      game.state.start('play', true, false, this.nextLevel);
    }
  };
  
  var playState = {
    init: function(level) {
      this.level = level;
    },
    create: function() {
      this.hp = START_HEARTS;
      
      this.cursors = game.input.keyboard.createCursorKeys();

      this.createLevel();
      this.createPan();
      this.createPigeon();
      this.createHearts();

      // set camera to follow pigeon
      game.camera.bounds = null;
      game.camera.follow(this.pigeon, null, 0.9, 0);
    },
    createLevel: function() {
      var collectedCounter = 0;
      var BASE_SIZE = 80;
      var levelDesc = game.cache.getJSON(this.level);
      this.background = game.add.image(0,0,levelDesc.background);

      this.obstacles = game.add.group();
      this.obstacles.enableBody = true;

      this.collectables = game.add.group();
      this.collectables.enableBody = true;  
      for (var itemDesc of levelDesc.obstacles) {
        if (itemDesc.image) {
          var item = this.obstacles.create(itemDesc.x, itemDesc.y, itemDesc.image);
          if(HITBOXES[itemDesc.image]) {
            var hitbox = HITBOXES[itemDesc.image];
            item.body.setSize(hitbox[0], hitbox[1], hitbox[2], hitbox[3]);
          }
          if(SCALING[itemDesc.image]) {
            var scale = SCALING[itemDesc.image];
            item.scale.setTo(scale, scale);
          }
          if (itemDesc.image == 'letterbox-open') {
            this.letterbox = item;
          }
        } else {
          var item = this.obstacles.create(itemDesc.x, itemDesc.y, 'placeholder');
          item.scale.setTo(itemDesc.width / BASE_SIZE, itemDesc.height / BASE_SIZE);
        }

        if (itemDesc.flip) {
          item.scale.x *= -1;
        }
        item.body.immovable = true;
      }
      for (var itemDesc of levelDesc.food) {
        var item = this.collectables.create(itemDesc.x, itemDesc.y, itemDesc.image);
        item.body.immovable = true;
      }
      
      this.end = levelDesc.end;
    },
    createPigeon: function() {
      this.pigeon = game.add.sprite(PIGEON_START_X, PIGEON_START_Y, 'pigeon');
      this.pigeon.anchor.setTo(0.5, 0.5);
      game.physics.arcade.enable(this.pigeon);
      this.pigeon.body.gravity.y = 300;
      this.pigeon.body.velocity.x = PIGEON_VELOCITY;
      this.pigeon.body.setSize(128 - 30, 60, 30, 30);
      this.pigeon.animations.add('fly', [0, 1], 5, false);
    },
    createPan: function() {
      this.pan = game.add.sprite(PIGEON_START_X - 300, PIGEON_START_Y, 'panny');
      this.pan.anchor.setTo(0.5, 0.3);
      game.physics.arcade.enable(this.pan);
      this.pan.body.velocity.x = PIGEON_VELOCITY;
      this.pan.animations.add('flyPan', [0, 1], 5, false);
    },
    resetPigeon: function() {
      this.pigeon.body.x = PIGEON_START_X;
      this.pigeon.body.y = PIGEON_START_Y;
      this.pigeon.body.velocity.x = PIGEON_VELOCITY;
      game.camera.x = 0;
    },
    resetPan: function() {
      this.pan.body.x = PIGEON_START_X - 300;
      this.pan.body.y = PIGEON_START_Y;
      this.pan.body.velocity.x = PIGEON_VELOCITY / 2;
    },
    createHearts: function(){
    this.hearts = game.add.group();
    for(var i = 0; i < MAX_HEARTS; i++){
      var heart = this.hearts.create(0,0, 'heart');
      heart.fixedToCamera = true;
      heart.cameraOffset.setTo(20 + i *22 ,20);
    }
  },
    update: function() {
      // collision detection
      if (game.physics.arcade.collide(this.pigeon, this.obstacles)) {
        this.resetPigeon();
        this.resetPan();
        this.hp -= 1;
        if (this.hp <= 0) {
          game.state.start('boot', true, false, {nextLevel: 'level0'})
        }
      };
      if (game.physics.arcade.collide(this.pigeon, this.pan)) {
        game.state.start('boot', true, false, {level: this.level, panned: true})
      }
      // collect foods
      game.physics.arcade.overlap(this.pigeon, this.collectables, this.collect, null, this);
      // handle inputs
      this.updatePigeon();
      // background parallax and health points
      this.background.x = game.camera.x / 3;
      this.updateHearts();
      
      if (this.pigeon.x >= this.end - 500 && this.letterbox) {
        this.letterbox.loadTexture('letterbox-closed');
      }
      if (this.pigeon.x >= this.end) {
        game.state.start('boot', true, false, {winner: true, nextLevel: getNextLevel(this.level) })
      }
      
      this.pan.body.y += 0.02 * (this.pigeon.body.y - this.pan.body.y);
      var modifier = Math.abs(this.pan.body.x - this.pigeon.body.x) > 200 ? 0.05 : 0.01;
      this.pan.body.velocity.x += modifier * (this.pigeon.body.velocity.x - this.pan.body.velocity.x);
      this.pan.body.velocity.x = Math.max(210, this.pan.body.velocity.x);
      this.pan.animations.play('flyPan', this.pan.body.velocity.x / 50);
    },
    updatePigeon: function updatePigeon() {
      // pigeon controls
      if (this.cursors.up.isDown) {
        this.pigeon.body.velocity.y -= 50;
      }
      if (this.cursors.down.isDown) {
        this.pigeon.body.velocity.y += 50;
      }
      if (this.cursors.right.isDown) {
        this.pigeon.body.velocity.x += 50;
      }
      if (this.cursors.left.isDown) {
        this.pigeon.body.velocity.x -= 10;
      }
      // limit pigeon speed
      this.pigeon.body.velocity.x = Math.max(50, this.pigeon.body.velocity.x);
      this.pigeon.body.velocity.x = Math.min(400, this.pigeon.body.velocity.x);
      this.pigeon.body.velocity.y = Math.max(-200, this.pigeon.body.velocity.y);
      this.pigeon.body.velocity.y = Math.min(200, this.pigeon.body.velocity.y);
      // animation speed is dependant on pigeon speed
      this.pigeon.animations.play('fly', this.pigeon.body.velocity.x / 50);
    },
    updateHearts: function() {
      for(var i = 0; i < MAX_HEARTS; i++){
        var heart = this.hearts.children[i];
        heart.visible = i < this.hp;
      }
    },
    collect: function(player, collectable){
      collectable.kill();
      this.hp = Math.min(this.hp + 1, MAX_HEARTS);
    }
  }

  
  var game = new Phaser.Game(1280, 720, Phaser.CANVAS, '');
  game.state.add('boot', bootState);
  game.state.add('play', playState);
  game.state.start('boot', true, false, {nextLevel: window.location.search ? window.location.search.substr(1) : 'level0', initial: true });
}
  